
//  TarasBY:       

int    MagicNumber_Buy_2 =  11002;
//================================================================================================
extern string  Parameters_LotsOptimized = "========== ==========";
extern bool    MoneyManagement  = false;    
extern double  MaximumRisk      = 0.02;
extern double  MaxLots          = 5;
extern double  DecreaseFactor   = 1;
//================================================================================================
extern string  Parameters_EAs_Management = "========== ==========";
extern bool    Use_EAs_Management  = false;
extern int     Quantity_EAs        = 3;
//================================================================================================
extern string  Parameters_Trade = "==== ====";
extern double  Lots                   = 1;
extern bool    Additional_Decimals    = true;
//+==============================================================================================+
//|                                                                                              |
//|                                     B U Y _ 2                                                |
//|                                                                                              |
//+==============================================================================================+
extern bool    BUY_Signal_2              = true;
extern int     StopLoss_BUY_2            = 125;
extern int     TakeProfit_BUY_2          = 300;
extern int     TrailingStop_BUY_2        = 50;
extern int     B2_RSI                    = 2;
extern int     B2_RSI_Day                = 47;
extern int     B2_i_RSI                  = 3;
//================================================================================================
extern string  Parameters_Trailing = "========== Trailing Parameters ==========";  
extern bool    UseTrailing     = true;
//extern bool    UseClosePositions = true;
extern bool    ProfitTrailing  = true; 
extern int     TrailingStep    = 1;
//extern int     Slippage            = 8;
//================================================================================================
//color  clModifyBuy  = Aqua;            
//color  clModifySell = Tomato;
//static int      prevtime = 0;
//static int      spread = 3;
int    gi_MyOrders, gi_dig, decimals = 1;
double gd_Point, gd_Trail, gd_TrailStep, myStopLoss = 0.0, myTakeProfit = 0.0,
       gd_MINLOT;
#include <b-PSI@TradeLight.mqh>
//#include <stdlib.mqh>
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    gi_dig = LotDecimal();
    gd_Point = Point;
    gd_MINLOT = MarketInfo (Symbol(), MODE_MINLOT);
    if (Additional_Decimals) decimals = 10;
    gd_Trail = TrailingStop_BUY_2 * gd_Point * decimals;
    gd_TrailStep = TrailingStep * gd_Point * decimals;
    if (StopLoss_BUY_2 > 0) myStopLoss = NormalizeDouble (StopLoss_BUY_2 * gd_Point * decimals, Digits);
    if (TakeProfit_BUY_2 > 0) myTakeProfit = NormalizeDouble (TakeProfit_BUY_2 * gd_Point * decimals, Digits);
    //----     
    fInit_TradeLight();
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//---------------------------------B-U-Y-----------------------------------------      
    gi_MyOrders = openPositions_Buy_2();
    if (gi_MyOrders == 0)
    {
        if (AccountFreeMargin() < 1000.0 * LotsOptimized_BUY_2())
        {
            Print ("We have no money. Free Margin = ", AccountFreeMargin());        
            return (0);
        }
        if (fBUY_Signal_2()) OpenBuyOrder_BUY_2();
    }
    else if (UseTrailing) TrailingPositions_BUY_2();
//---------------------------------B-U-Y----------------------------------------- 
    return (0);
}
//+==============================================================================================+
//|                                                                                              |
//|                                     B U Y _ 2                                                |
//|                                                                                              |
//+==============================================================================================+
bool fBUY_Signal_2()
{
    if (!BUY_Signal_2) return (false);
    double B2_RSI_Day_S = iRSI (0, PERIOD_W1, B2_RSI, PRICE_LOW, 0),
           B2_RSI_Day_P = iRSI (0, PERIOD_W1, B2_RSI, PRICE_LOW, B2_i_RSI),
           B2_RSI_Day_P_2 = iRSI (0, PERIOD_W1, B2_RSI, PRICE_LOW, B2_i_RSI + 1);
    if (B2_RSI_Day_S < B2_RSI_Day
    || B2_RSI_Day_P > B2_RSI_Day_S
    || B2_RSI_Day_P_2 > B2_RSI_Day_P
    || B2_RSI_Day_P_2 > B2_RSI_Day) return (false);
    return (true);
}

//+==============================================================================================+
void prtAlert (string str = "")
{Alert (StringConcatenate (Symbol(), " - ", str));}
//+==============================================================================================+

//+==============================================================================================+
//|                                                                                              |
//|                                     B U Y                                                    |
//|                                                                                              |
//+==============================================================================================+

void OpenBuyOrder_BUY_2()
{
    int ticket = fOrderSend (Symbol(), OP_BUY, LotsOptimized_BUY_2(), NormalizeDouble (Ask, Digits), Slippage, myStopLoss, myTakeProfit, "", MagicNumber_Buy_2,0);
    if (ticket > 0) prtAlert ("OpenBuy_Signal_BUY_2 for " + DoubleToStr (Ask, Digits));
}

//+==============================================================================================+
//|                                                                                              |
//|                                     B U Y                                                    |
//|                                                                                              |
//+==============================================================================================+  
 
int openPositions_Buy_2()
{
    int op = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)                                // scan all orders and positions...
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderMagicNumber() != MagicNumber_Buy_2) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderType() == OP_BUY) op++; 
    } 
    return (op);
}


//+==============================================================================================+
//|                                                                                              |
//|                                     B U Y   T R A I L I N G                                  |
//|                                                                                              |
//+==============================================================================================+
                     
void TrailingPositions_BUY_2()
{
    double pBid = Bid, ld_NewSL;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != Symbol()) continue;
        if (OrderMagicNumber() != MagicNumber_Buy_2) continue;
        if (OrderType() != OP_BUY) continue;
        if (!ProfitTrailing || (pBid - OrderOpenPrice()) > gd_Trail)
        {
            ld_NewSL = pBid - gd_Trail;
            if (OrderStopLoss() + gd_TrailStep < ld_NewSL || OrderStopLoss() == 0)
            {
                fModify_SelectOrder (OrderTicket(), OrderOpenPrice(), NormalizeDouble (ld_NewSL, Digits), OrderTakeProfit());
                return;
            }
        }
    }
}
//+==============================================================================================+
//|                                                                                              |
//|                                     BUY  MONEY MANAGEMENT                                    |
//|                                                                                              |
//+==============================================================================================+


double LotsOptimized_BUY_2()
{
    if (MoneyManagement)
    {
        double lot;
        int    orders = OrdersHistoryTotal(), losses = 0;                 
        if (Use_EAs_Management) lot = AccountFreeMargin() / Quantity_EAs * MaximumRisk / 1000.0;
        else lot = AccountEquity() * MaximumRisk / 1000.0;
        if (DecreaseFactor > 0)
        {
            for (int i = orders - 1; i >= 0; i--)
            {
                if (!OrderSelect (i, SELECT_BY_POS, MODE_HISTORY)) {Print ("Error in history!"); continue;}
                if (OrderSymbol() != Symbol()) continue;
                if (OrderType() > 1) continue;
                if (OrderMagicNumber() != MagicNumber_Buy_2) continue;
                //----
                if (OrderProfit() > 0) break;
                if (OrderProfit() < 0) losses++;
            }
            //if (losses > 0) lot -= lot * losses / DecreaseFactor;
        }
    }
    else lot = Lots;
    lot = MathMax (lot, gd_MINLOT);
    //--- for CONTEST only
    lot = MathMin (lot, MaxLots);
    return (NormalizeDouble (lot, gi_dig));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|        ,                              |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int LotDecimal()
{return (MathCeil (MathAbs (MathLog (MarketInfo (Symbol(), MODE_LOTSTEP)) / MathLog (10))));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

